## sdltrs-1.2.33.tar.bz2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5...3.13)

project(sdltrs C)

include(GNUInstallDirs)
include(TestBigEndian)

set(CMAKE_C_FLAGS
	"-g -Wall -Wextra -Wno-unused-parameter -Wno-unused-result -O2 ${CMAKE_C_FLAGS}"
)

set(SOURCES
	src/debug.c
	src/dis.c
	src/error.c
	src/main.c
	src/trs_cassette.c
	src/trs_clones.c
	src/trs_cmd_rom.c
	src/trs_cp500.c
	src/trs_disk.c
	src/trs_hard.c
	src/trs_imp_exp.c
	src/trs_interrupt.c
	src/trs_io.c
	src/trs_memory.c
	src/trs_mkdisk.c
	src/trs_options.c
	src/trs_printer.c
	src/trs_sdl_gui.c
	src/trs_sdl_interface.c
	src/trs_sdl_keyboard.c
	src/trs_state_save.c
	src/trs_stringy.c
	src/trs_uart.c
	src/z80.c
	src/PasteManager.c
)

add_executable(sdltrs ${SOURCES})

add_definitions(-DROM_PATH="${ROM_PATH}")
message("-- ROM path set to: '${ROM_PATH}'")

test_big_endian(BIGENDIAN)
if (${BIGENDIAN})
	add_definitions(-Dbig_endian)
endif ()

option(DISKIMG	"Install disk images with utilities"	ON)
option(FASTMOVE	"Fast inaccurate Z80 block moves"	OFF)
option(HTMLDOC	"Install documentation in HTML format"	ON)
option(ICONS	"Install icons and desktop file"	ON)
option(OLDSCAN	"Display Scanlines using old method"	OFF)
option(NOX	"Build SDL 1.2 version without X"	OFF)
option(READLINE	"Readline support for zbx debugger"	ON)
option(SDL1	"Use SDL version 1.2 instead of SDL2"	OFF)
option(ZBX	"Build with integrated Z80 debugger"	ON)

if (FASTMOVE)
	add_definitions(-DFAST_MOVE)
	message("-- Fast inaccurate Z80 block moves")
endif ()

if (OLDSCAN)
	add_definitions(-DOLD_SCANLINES)
	message("-- Display Scanlines using old method")
endif ()

if (READLINE AND ZBX)
	find_path(Readline_ROOT_DIR
		NAMES include/readline/readline.h
	)
	find_path(Readline_INCLUDE_DIR
		NAMES readline/readline.h
		HINTS ${Readline_ROOT_DIR}/include
	)
	find_library(Readline_LIBRARY
		NAMES readline
		HINTS ${Readline_ROOT_DIR}/lib
	)
	if (Readline_LIBRARY)
		find_package(Curses QUIET)
		if (CURSES_LIBRARIES)
			include_directories(${CURSES_INCLUDE_DIR})
			target_link_libraries(sdltrs ${CURSES_LIBRARIES})
		endif ()
		add_definitions(-DREADLINE)
		message("-- Readline support for zbx debugger")
		include_directories(${Readline_INCLUDE_DIR})
		target_link_libraries(sdltrs ${Readline_LIBRARY})
	else ()
		message("-- Readline NOT FOUND")
	endif ()
endif ()

if (SDL1 OR NOX)
	if (NOX)
		add_definitions(-DNOX)
		message("-- Build SDL 1.2 version without X")
	else ()
		find_package(X11 REQUIRED)
		message("-- Use SDL version 1.2 instead of SDL2")
		include_directories(${X11_INCLUDE_DIR})
		target_link_libraries(sdltrs ${X11_LIBRARIES})
	endif ()
	set(SDL_CONFIG "sdl-config")
else ()
	add_definitions(-DSDL2)
	set(SDL_CONFIG "sdl2-config")
endif ()

find_program(SDL "${SDL_CONFIG}")
if (NOT SDL)
	message(FATAL_ERROR "${SDL_CONFIG} NOT FOUND")
else ()
	execute_process(COMMAND ${SDL} --cflags
			OUTPUT_VARIABLE SDL_CFLAGS
			OUTPUT_STRIP_TRAILING_WHITESPACE)
	execute_process(COMMAND ${SDL} --libs
			OUTPUT_VARIABLE SDL_LIBS
			OUTPUT_STRIP_TRAILING_WHITESPACE)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${SDL_CFLAGS}")
	if (ZBX)
		add_definitions(-DZBX)
		message("-- Build with integrated Z80 debugger")
		if (MINGW OR MSYS OR WIN32)
			string(REPLACE " -mwindows" "" SDL_LIBS "${SDL_LIBS}")
		endif ()
	endif ()
	message("-- Found SDL: ${SDL_LIBS}")
	target_link_libraries(sdltrs ${SDL_LIBS})
endif ()

install(TARGETS sdltrs		DESTINATION ${CMAKE_INSTALL_BINDIR}/)
install(FILES src/sdltrs.1	DESTINATION ${CMAKE_INSTALL_MANDIR}/man1/)
install(FILES LICENSE		DESTINATION ${CMAKE_INSTALL_DOCDIR}/)

if (HTMLDOC)
message("-- Install documentation in HTML format")
install(DIRECTORY html		DESTINATION ${CMAKE_INSTALL_DOCDIR}/)
endif ()

if (DISKIMG)
message("-- Install disk images with utilities")
install(DIRECTORY diskimages/	DESTINATION ${CMAKE_INSTALL_DATADIR}/sdltrs/)
endif ()

if (ICONS)
message("-- Install icons and desktop file")
install(FILES sdltrs.desktop	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications/)
install(FILES icons/sdltrs.png	DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps/)
install(FILES icons/sdltrs.svg	DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
install(FILES icons/sdltrs.xpm	DESTINATION ${CMAKE_INSTALL_DATADIR}/pixmaps/)
endif ()

=== meson_options.txt ===
option('FASTMOVE',
	description	: 'Fast inaccurate Z80 block moves',
	type		: 'boolean',
	value		: false
)

option('OLDSCAN',
	description	: 'Display Scanlines using old method',
	type		: 'boolean',
	value		: false
)

option('NOX',
	description	: 'Build SDL 1.2 version without X',
	type		: 'boolean',
	value		: false
)

option('READLINE',
	description	: 'Readline support for zbx debugger',
	type		: 'boolean',
	value		: true
)

option('ROM_PATH',
	description	: 'Set path prefix for ROM files',
	type		: 'string',
	value		: '""'
)

option('SDL1',
	description	: 'Use SDL version 1.2 instead of SDL2',
	type		: 'boolean',
	value		: false
)

option('ZBX',
	description	: 'Build with integrated Z80 debugger',
	type		: 'boolean',
	value		: true
)

=== src/Makefile ===
PROG	 = sdltrs

SRCS	+= debug.c
SRCS	+= dis.c
SRCS	+= error.c
SRCS	+= main.c
SRCS	+= trs_cassette.c
SRCS	+= trs_clones.c
SRCS	+= trs_cmd_rom.c
SRCS	+= trs_cp500.c
SRCS	+= trs_disk.c
SRCS	+= trs_hard.c
SRCS	+= trs_imp_exp.c
SRCS	+= trs_interrupt.c
SRCS	+= trs_io.c
SRCS	+= trs_memory.c
SRCS	+= trs_mkdisk.c
SRCS	+= trs_options.c
SRCS	+= trs_printer.c
SRCS	+= trs_sdl_gui.c
SRCS	+= trs_sdl_interface.c
SRCS	+= trs_sdl_keyboard.c
SRCS	+= trs_state_save.c
SRCS	+= trs_stringy.c
SRCS	+= trs_uart.c
SRCS	+= z80.c
SRCS	+= PasteManager.c

OBJS	 = ${SRCS:.c=.o}

.PHONY: all bsd clean depend nox os2 sdl sdl2 win32 win64 wsdl2

all:
	@echo "make (bsd | clean | depend | nox | os2 | sdl | sdl2 | win32 | win64 | wsdl2)"

bsd:
	make -f BSDmakefile

clean:
	rm -f ${OBJS} ${PROG}

depend:
	makedepend -Y -- ${CFLAGS} -- ${SRCS} 2>&1 | \
		(egrep -v 'cannot find|not in' || true)

nox:	ENDIAN	 = $(shell echo "ab" | od -x | grep "6261" > /dev/null || echo "-Dbig_endian")
nox:	SDL_INC	?= $(shell sdl-config --cflags)
nox:	SDL_LIB	?= $(shell sdl-config --libs)
nox:	MACROS	+= -DNOX
nox:	READLINE?= -DREADLINE
nox:	${PROG}

os2:	SDL_INC	?= $(shell sdl-config --cflags)
os2:	SDL_LIB	?= $(shell sdl-config --libs)
os2:	MACROS	+= -DNOX
os2:	LDFLAGS	+= -Zomf
os2:	${PROG}

sdl:	ENDIAN	 = $(shell echo "ab" | od -x | grep "6261" > /dev/null || echo "-Dbig_endian")
sdl:	SDL_INC	?= $(shell sdl-config --cflags)
sdl:	SDL_LIB	?= $(shell sdl-config --libs)
sdl:	READLINE?= -DREADLINE
sdl:	X11INC	?= -I/usr/include/X11
sdl:	X11LIB	?= -L/usr/lib/X11 -lX11
sdl:	${PROG}

sdl2:	ENDIAN	 = $(shell echo "ab" | od -x | grep "6261" > /dev/null || echo "-Dbig_endian")
sdl2:	SDL_INC	?= $(shell sdl2-config --cflags)
sdl2:	SDL_LIB	?= $(shell sdl2-config --libs)
sdl2:	MACROS	+= -DSDL2
sdl2:	READLINE?= -DREADLINE
sdl2:	${PROG}

win32:	MINGW	?= \MinGW
win32:	CC	 = ${MINGW}\bin\gcc.exe
win32:	SDL_INC	?= -I${MINGW}\include\SDL
win32:	SDL_LIB	?= -L${MINGW}\lib -lmingw32 -lSDLmain -lSDL
win32:	${PROG}

win64:	MINGW64	?= \MinGW64
win64:	CC	 = ${MINGW64}\bin\gcc.exe
win64:	SDL_INC	?= -I${MINGW64}\include\SDL2
win64:	SDL_LIB	?= -L${MINGW64}\lib -lmingw32 -lSDL2main -lSDL2
win64:	MACROS	+= -DSDL2
win64:	${PROG}

wsdl2:	MINGW	?= \MinGW
wsdl2:	CC	 = ${MINGW}\bin\gcc.exe
wsdl2:	SDL_INC	?= -I${MINGW}\include\SDL2
wsdl2:	SDL_LIB	?= -L${MINGW}\lib -lmingw32 -lSDL2main -lSDL2
wsdl2:	MACROS	+= -DSDL2
wsdl2:	${PROG}

MSYS		:=$(if $(findstring Msys, $(shell uname -a)), Msys)
SSPLIB		:=$(if ${MSYS},-lssp,)
READLINELIBS	 =$(if ${READLINE},-lreadline,)
MACROS		+= -DROM_PATH='"${ROM_PATH}"'
ZBX		?= -DZBX
CFLAGS		?= -g -O2 -Wall
CFLAGS		+= ${SDL_INC} ${X11INC} ${ENDIAN} ${MACROS} ${READLINE} ${ZBX}

${PROG}: ${OBJS}
	${CC} -o ${PROG} ${OBJS} ${SDL_LIB} ${X11LIB} ${LDFLAGS} ${READLINELIBS} ${SSPLIB}

=== debian/changelog ===
sdltrs (1.2.33-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sat, 09 Aug 2025 18:00:33 +0100

sdltrs (1.2.32-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 06 Apr 2025 08:39:32 +0100

sdltrs (1.2.31-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 24 Nov 2024 13:07:31 +0100

sdltrs (1.2.30-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 18 Aug 2024 07:18:30 +0100

sdltrs (1.2.29-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 04 Apr 2024 11:17:29 +0100

sdltrs (1.2.28-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sat, 19 Aug 2023 10:28:19 +0100

sdltrs (1.2.27-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 09 Apr 2023 08:27:07 +0100

sdltrs (1.2.26-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sat, 18 Feb 2023 11:05:26 +0100

sdltrs (1.2.25-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 18 Dec 2022 09:49:25 +0100

sdltrs (1.2.24-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 24 Jul 2022 00:28:33 +0100

sdltrs (1.2.23-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 27 Mar 2022 12:23:52 +0100

sdltrs (1.2.22-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 06 Feb 2021 08:24:22 +0100

sdltrs (1.2.21-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 28 Nov 2021 09:18:45 +0100

sdltrs (1.2.20-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sat, 31 Jul 2021 18:20:30 +0100

sdltrs (1.2.19-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 06 Jun 2021 09:46:19 +0100

sdltrs (1.2.18-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 09 May 2021 10:03:54 +0100

sdltrs (1.2.17-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 04 Apr 2021 09:44:28 +0100

sdltrs (1.2.16-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 28 Feb 2021 13:23:09 +0100

sdltrs (1.2.15-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 24 Jan 2021 12:38:01 +0100

sdltrs (1.2.14-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 29 Nov 2020 12:51:14 +0100

sdltrs (1.2.13-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 27 Sep 2020 10:16:47 +0100

sdltrs (1.2.12-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 16 Aug 2020 07:28:00 +0100

sdltrs (1.2.11-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 28 Jun 2020 12:19:36 +0100

sdltrs (1.2.10-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 24 May 2020 15:22:15 +0100

sdltrs (1.2.9a-1) unstable; urgency=medium

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 19 Apr 2020 15:38:19 +0100

sdltrs (1.2.9-1) unstable; urgency=low

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 12 Apr 2020 11:29:28 +0100

sdltrs (1.2.8-1) unstable; urgency=low

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 22 Mar 2020 12:06:30 +0100

sdltrs (1.2.7-1) unstable; urgency=low

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sat, 25 Jan 2020 11:12:24 +0100

sdltrs (1.2.6-1) unstable; urgency=low

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 29 Dec 2019 13:06:07 +0100

sdltrs (1.2.5-1) unstable; urgency=low

  * New upstream release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sat, 21 Dec 2019 16:01:28 +0100

sdltrs (1.2.4-1) unstable; urgency=low

  * Initial release

 -- Jens Guenther <Jenz.Guenther@T-Online.de>  Sun, 24 Nov 2019 18:22:07 +0100

=== debian/control ===
Source: sdltrs
Section: contrib/otherosfs
Priority: optional
Maintainer: Jens Guenther <Jenz.Guenther@T-Online.de>
Build-Depends: debhelper(>= 7), libreadline-dev, libsdl1.2-dev
Standards-Version: 3.9.6
Homepage: https://gitlab.com/jengun/sdltrs/

Package: sdltrs
Architecture: any
Depends: ${shlibs:Depends}
Description: TRS-80 Model I/III/4/4P emulator for SDL
 SDLTRS is an SDL-based emulator for the Tandy/Radio Shack line of Zilog
 Z80-based microcomputers popular in the late 1970s and early 1980s.  It
 features cassette, floppy, and hard drive emulation, timer interrupt
 emulation, file import and export from the host operating system, support
 for most of the undocumented Z80 instructions, and a built-in debugger.
 Real floppy drives can be used and application-based sound can be
 played and real cassettes read and written directly through the
 sound card or via WAVE files.  Several Hi-Res graphics cards are
 emulated and, in Model 4/4P mode, mice are supported.  There is also
 real-time clock, sound card, serial port, joystick, and CPU clock
 speedup emulation.
 .
 SDLTRS requires ROM images from the original machines.  The ROMs are
 copyrighted by Radio Shack and are not freely licensed.  (Exception: in
 Model 4P mode, a freely-licensed boot ROM included with this package can be
 used to boot a Model 4 operating system from a diskette image.)

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE := sdltrs

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-arch
build-arch: build-stamp
build-stamp:
	dh_testdir
	./autogen.sh
	./configure --prefix=/usr --enable-readline --enable-sdl1 --enable-zbx
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f ./aclocal.m4 ./compile ./config.* ./configure \
	      ./depcomp ./install-sh ./missing ./Makefile.in

# Build architecture-dependent files here.
binary-arch: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the files into debian/$(PACKAGE)
	$(MAKE) install prefix=`pwd`/debian/$(PACKAGE)/usr mandir='$${prefix}/share/man'

	dh_installchangelogs
	dh_installdocs
	dh_installman
	dh_installmenu

	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-arch

.PHONY: build clean binary-arch binary
